Overview | Package | Class | Deprecated | Index | Help
| Groovy Documentation
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.gradle.api.tasks.javadoc
[Java] Class Javadoc

    java.lang.Object
      org.gradle.api.internal.ConventionTask
          org.gradle.api.tasks.SourceTask
              org.gradle.api.tasks.javadoc.Javadoc

    public class Javadoc
    extends SourceTask

Generates HTML API documentation for Java classes.

If you create your own Javadoc tasks remember to specify the 'source' property! Without source the Javadoc task will not create any documentation. Example:

     apply plugin: 'java'

     task myJavadocs(type: Javadoc) {
       source = sourceSets.main.allJava
     }

An example how to create a task that runs a custom doclet implementation:

     apply plugin: 'java'

     configurations {
       jaxDoclet
     }

     dependencies {
       //jaxDoclet "some.interesting:Dependency:1.0"
     }

     task generateRestApiDocs(type: Javadoc) {
       source = sourceSets.main.allJava
       destinationDir = reporting.file("rest-api-docs")
       options.docletpath = configurations.jaxDoclet.files.asType(List)
       options.doclet = "com.lunatech.doclets.jax.jaxrs.JAXRSDoclet"
       options.addStringOption("jaxrscontext", "http://localhost:8080/myapp")
     }

Method Summary
`protected void` | `generate()`
`FileCollection` | `getClasspath()` Returns the classpath to use to resolve type references in the source code.
`File` | `getDestinationDir()`
`String` | `getExecutable()` Returns the Javadoc executable to use to generate the Javadoc.
`String` | `getMaxMemory()` Returns the amount of memory allocated to this task.
`MinimalJavadocOptions` | `getOptions()` Returns the Javadoc generation options.
`File` | `getOptionsFile()`
`String` | `getTitle()`
`boolean` | `isFailOnError()` Specifies whether this task should fail when errors are encountered during Javadoc generation.
`boolean` | `isVerbose()` Returns whether Javadoc generation is accompanied by verbose output.
`void` | `options(Closure block)` Convenience method for configuring Javadoc generation options.
`void` | `setClasspath(FileCollection classpath)` Sets the classpath to use to resolve type references in this source code.
`void` | `setDestinationDir(File destinationDir)`
`void` | `setExecutable(String executable)`
`void` | `setFailOnError(boolean failOnError)`
`void` | `setMaxMemory(String maxMemory)` Sets the amount of memory allocated to this task.
`void` | `setOptions(MinimalJavadocOptions options)` Sets the Javadoc generation options.
`void` | `setTitle(String title)`
`void` | `setVerbose(boolean verbose)` Sets whether Javadoc generation is accompanied by verbose output or not.

Methods inherited from class SourceTask
exclude, exclude, exclude, exclude, getDefaultSource, getExcludes, getIncludes, getSource, include, include, include, include, setExcludes, setIncludes, setSource, source

Method Detail

### generate

    @TaskAction
    protected void generate()

### getClasspath

    @InputFiles
    public FileCollection getClasspath()

  Returns the classpath to use to resolve type references in the source code.
  Returns:
    The classpath.

### getDestinationDir

    @OutputDirectory
    public File getDestinationDir()

  Returns the directory to generate the documentation into.

  Returns:
    The directory.

### getExecutable

    @Input
    @Optional
    public String getExecutable()

  Returns the Javadoc executable to use to generate the Javadoc. When `null`, the Javadoc executable for the current JVM is used.
  Returns:
    The executable. May be null.

### getMaxMemory

    public String getMaxMemory()

  Returns the amount of memory allocated to this task.

### getOptions

    @Nested
    public MinimalJavadocOptions getOptions()

  Returns the Javadoc generation options.
  Returns:
    The options. Never returns null.

### getOptionsFile

    public File getOptionsFile()

### getTitle

    @Input
    @Optional
    public String getTitle()

  Returns the title for the generated documentation.

  Returns:
    The title, possibly null.

### isFailOnError

    @Input
    public boolean isFailOnError()

  Specifies whether this task should fail when errors are encountered during Javadoc generation. When `true`, this task will fail on Javadoc error. When `false`, this task will ignore Javadoc errors.

### isVerbose

    public boolean isVerbose()

  Returns whether Javadoc generation is accompanied by verbose output.
  See Also:
    setVerbose(boolean)

### options

    public void options(Closure block)

  Convenience method for configuring Javadoc generation options.
  Parameters:
    `block` - The configuration block for Javadoc generation options.

### setClasspath

    public void setClasspath(FileCollection classpath)

  Sets the classpath to use to resolve type references in this source code.
  Parameters:
    `classpath` - The classpath. Must not be null.

### setDestinationDir

    public void setDestinationDir(File destinationDir)

  Sets the directory to generate the documentation into.

### setExecutable

    public void setExecutable(String executable)

### setFailOnError

    public void setFailOnError(boolean failOnError)

### setMaxMemory

    public void setMaxMemory(String maxMemory)

  Sets the amount of memory allocated to this task.
  Parameters:
    `maxMemory` - The amount of memory

### setOptions

    public void setOptions(MinimalJavadocOptions options)

  Sets the Javadoc generation options.
  Parameters:
    `options` - The options. Must not be null.

### setTitle

    public void setTitle(String title)

  Sets the title for the generated documentation.

### setVerbose

    public void setVerbose(boolean verbose)

  Sets whether Javadoc generation is accompanied by verbose output or not. The verbose output is done via println (by the underlying Ant task). Thus it is not handled by our logging.
  Parameters:
    `verbose` - Whether the output should be verbose.

Gradle API 1.10